

#ifndef  __CPU_H__
#define  __CPU_H__


#include <stdint.h>
#include "MemoryUnit.H"


extern "C++" {
	namespace v1processor {
		using namespace std;

		class CPU {
			protected:
				MemoryUnit *memoryUnit;
				bool justReseted;
			public:
				bool isJustReseted() { return this->justReseted; };
				int16_t ra, rb, rc, sp, pc, ir;
				CPU(MemoryUnit &memoryUnit);
				void reset();
				int16_t *getRegister(uint8_t r);
				void step();
		};

		ostream &operator << (ostream &os, CPU &cpu);
	}
}


#endif  // __CPU_H__
